//+=========================================================================================================+\\
//|         Made by..                                                                                       |\\
//|        ____   ____  _                __          _                                                      |\\
//|       |_  _| |_  _|(_)              [  |        / |_                                                    |\\
//|         \ \   / /  __   .--.   .--.  | |  ,--. `| |-' .--.   _ .--.                                     |\\
//|          \ \ / /  [  | ( (`\]/ .'`\ \| | `'_\ : | | / .'`\ \[ `/'`\]                                    |\\
//|           \ ' /    | |  `'.'.| \__. || | // | |,| |,| \__. | | |                                        |\\
//|            \_/    [___][\__) )'.__.'[___]\'-;__/\__/ '.__.' [___]                                       |\\
//|                             BL_ID: 20490                                                                |\\
//|             Forum Profile: http://forum.blockland.us/index.php?action=profile;u=40877;                  |\\
//|                                                                                                         |\\
//|     Random Item Event                                                                                   |\\
//|         Item events, can go up to 4 items restricting to be picked.                                     |\\
//+=========================================================================================================+\\

//Load support from RTB
exec("./support_itemstrings.cs");

//Adds a new item in their inv if there is free space.
//@param    ItemData    item    Attempts to add a new item if it exists.
function Player::addNewItem(%this,%item)
{
    if(!isObject(%this)) return;
    if(!isObject(%item)) return;
    if(%item.getClassName() !$= "ItemData") return;
    for(%i = 0; %i < %this.getDatablock().maxTools; %i++)
    {
        %tool = %this.tool[%i];
        if(!isObject(%tool))
        {
            %this.tool[%i] = nameToID(%item);
            %this.weaponCount++;
            messageClient(%this.client,'MsgItemPickup','',%i,nameToID(%item));
            break;
        }
    }
}

//Adds a random item, three modes.. Item, gives random items, Weapon, gives out weapons; Other, sometimes weapons/items have a different classname/category.. dunno why
//@param    ItemData item[%i]   Restricts the item being picked.
function Player::addNewRandom(%this,%mode)
{
    if(!isObject(%this)) return;
    //messageClient(%this.client,'',"------------------------------------- MODE " @ %mode);
    for(%i = 0; %i < DataBlockGroup.getCount(); %i++)
    {
        %obj = DataBlockGroup.getObject(%i);
        %b = "HammerItem WrenchItem PrintGun WandItem fillcanItem DuplorcatorItem DuplicatorItem";
        %d = %obj.image.projectile.directDamage + %obj.image.projectile.explosion.radiusDamage + %obj.image.raycastDirectDamage;
        if(%obj.image.raycastCritDirectDamageType)
            %d *= 3;
        %cate = strlwr(%obj.category);
        if(%obj.getClassName() $= "ItemData" && %obj.uiName !$= "") //Here we go
            if((%mode == 0 && (strPos(%cate,"tool") >= 0 || strPos(%cate,"item") >= 0)) || 
                (%mode == 1 && strPos(%cate,"weapon") >= 0 && !hasItemOnList(%b,%obj.getName())) || 
                (%mode == 2 && strPos(%cate,"tool") == -1 && strPos(%cate,"weapon") == -1) ||
                (%mode == 3 && %d > 100 && !hasItemOnList(%b,%obj.getName()) && strPos(%cate,"weapon") >= 0) ||
                (%mode == 4 && %d < 101 && !hasItemOnList(%b,%obj.getName()) && strPos(%cate,"weapon") >= 0)
                )
            {
                %item[%itemCount++] = %obj;
                //messageClient(%this.client,'',%obj.getName() @ " > " @ %obj.image.projectile.directDamage + %obj.image.projectile.explosion.radiusDamage @ " total damage | " @ %obj.category);
            }
    }
    //messageClient(%this.client,'',"-------------------------------------");
    %this.addNewItem(%item[getRandom(1,%itemCount)]);
}

registerOutputEvent("Player","addNewItem","datablock ItemData");
registerOutputEvent("Player","addNewRandom","list Utility 0 Weapon 1 Other 2 OP 3 Not_OP 4");